stages:
  - build
  - test
  - deploy

build:
  stage: build
  image: docker:stable
  before_script:
    - df
    - cat /etc/resolv.conf
    - cat /etc/hosts
  services:
    - docker:18.09.7-dind
  # privileged: true
  script:
    - echo "Build Started"
    - docker build --network=host -t arawirelesshub/aramimo:v1.1 -f ./Dockerfile .
    - echo "Build Finished"
  only:
    - main  # Define when this job should run, e.g., only on the master branch.

test:
  stage: test
  image: docker:stable
  services:
    - docker:18.09.7-dind
  script:
    - docker build --network=host -t arawirelesshub/aramimo:v1.1 -f ./Dockerfile .
    - docker run -t -d --network=host --name aramimo arawirelesshub/aramimo:v1.1
    - docker exec aramimo ara-sklk-cli
    - echo "Testing the Skylark APIs"
    - docker exec aramimo python3 aramimo/test.py
    - docker stop aramimo
    - echo "Removing the test aramimo container"
    - docker rm aramimo
  only:
    - main  # Define when this job should run, e.g., only on the master branch.

deploy:
  stage: deploy
  image: docker:stable
  services:
    - docker:18.09.7-dind
  script:
    - echo "$DOCKER_PASSWORD" | docker login --username "$DOCKER_USERNAME" --password-stdin
    - echo "Docker login successful"
    - docker build --network=host -t arawirelesshub/aramimo:v1.1 -f ./Dockerfile .
    - echo "Container image build successful."
    - docker push arawirelesshub/aramimo:v1.1
    - echo "Container push to DockerHub successful."
  only:
    - main  # Define when this job should run, e.g., only on the master branch.
